package com.chinaitop.depot.api.controller;

import com.chinaitop.depot.api.model.qualitycheck.TStorageFoodbasicinfo;
import com.chinaitop.depot.api.model.qualitycheck.TStorageQualitycheckVo;
import com.chinaitop.depot.api.service.TStorageFoodbasicInfoService;
import com.chinaitop.depot.api.service.TStorageQualitycheckService;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author sunhongbing
 * @Date 2017/10/26
 */
@RestController
@RequestMapping(value={"/foodbasicinfo"})
@Api(value= "StorageFoodbasicInfoController", description = "粮情专卡控制类")
public class TStorageFoodbasicInfoController {
    @Resource
    private TStorageFoodbasicInfoService foodbasicInfoService;




    /**
     * 新增粮情专卡的数据进行保存
     * @param foodbasicinfoJson
     * @return
     */
    @RequestMapping(value="/save", produces = MediaType.APPLICATION_JSON_VALUE,method = RequestMethod.POST)
    @ApiOperation(value="封仓生成粮情专卡", notes = "封仓生成粮情专卡")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "foodbasicinfoJson", value = "粮情专卡基本信息JSON数据对象", paramType = "form"),
            @ApiImplicitParam(name = "storageQualitycheckJson", value = "粮情专卡JSON数据对象", paramType = "form"),
            @ApiImplicitParam(name = "orgId", value = "用户标识", paramType = "orgId")
    })
    public Map<String, Object> save(String foodbasicinfoJson,String storageQualitycheckJson,Integer orgId) {
        Map<String, Object> modelMap = new HashMap<>();
        ObjectMapper objectMapper=new ObjectMapper();
        TStorageFoodbasicinfo foodbasicInfo = new TStorageFoodbasicinfo();
        TStorageQualitycheckVo qualitycheckVo = new TStorageQualitycheckVo();
        try {
            //①保存储粮信息
            qualitycheckVo = (TStorageQualitycheckVo)objectMapper.readValue(storageQualitycheckJson,TStorageQualitycheckVo.class);
            foodbasicInfo = (TStorageFoodbasicinfo)objectMapper.readValue(foodbasicinfoJson,TStorageFoodbasicinfo.class);
            foodbasicInfoService.save(foodbasicInfo,qualitycheckVo,orgId);
            modelMap.put("status", "success");
        } catch (Exception e) {
            modelMap.put("status", "error");
            e.printStackTrace();
        }
        return modelMap;
    }





}
