package com.chinaitop.depot.api.controller;


import com.chinaitop.depot.api.constant.Constant;
import com.chinaitop.depot.api.model.ResponseEntity;
import com.chinaitop.depot.api.model.qualitycheck.*;
import com.chinaitop.depot.api.service.TStorageQualitycheckService;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.List;

/**
 * Created by product on 2017/10/11.
 */
@RestController
@RequestMapping(value = {"/qualitycheck"})
@Api(value= "StorageQualitycheckController", description = "质量管理控制类")
public class TStorageQualitycheckController {
    @Resource
    private TStorageQualitycheckService storageQualitycheckService;

    /**
     * 新增的数据进行保存
     * @param qualitycheckJson
     * @return
     * @throws JSONException 
     */
    @RequestMapping(value="/save", method = RequestMethod.POST)
    @ApiOperation(value="新增数据", notes = "新增数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "qualitycheckJson", value = "质量基础信息JSON数据对象", paramType = "form"),
            @ApiImplicitParam(name = "qualityJson", value = "质量检测信息JSON数据对象", paramType = "form")
    })
    public ResponseEntity save(@RequestBody String jsonStr) throws JSONException {
    	
    	//接收到的json字符串转为json对象
    	JSONObject jsObject = new JSONObject(jsonStr);
    	//获取属性
    	String qualitycheckJson = jsObject.optString("qualitycheckJson");
    	String qualityJson = jsObject.optString("qualityJson");
    	
        // JSON字符串转对象
        ObjectMapper mapper = new ObjectMapper();
        TStorageQualitycheck qualitycheck = null;
        //List<TStorageQualitycheckSon> qualitycheckone = null;
        List<TStorageQualitycheckSon> quality = null;
        try {
            qualitycheck = (TStorageQualitycheck)mapper.readValue(qualitycheckJson, TStorageQualitycheck.class);
            //logger.info("json转化为qualitycheck对象: {}",qualitycheck);
            //默认0:未封仓   1:已封仓
            qualitycheck.setSealStatus("0");
            qualitycheck.setHistoryStatus(0);//0:最新数据   1:历史数据
            Integer qualityCheckId = storageQualitycheckService.save(qualitycheck);
            //关联保存日常检查和第三方检测的检测信息 如果为空则是对初检 验收等操作
            /*if(StringUtils.isNoneBlank(qualityOneJson)){
                qualitycheckone = mapper.readValue(qualityOneJson,  new TypeReference<List<TStorageQualitycheckSon>>(){});
                for (int i = 0; i < qualitycheckone.size(); i++) {
                    qualitycheckone.get(i).setQualitycheckId(qualityCheckId);
                    storageQualitycheckService.saveOne(qualitycheckone.get(i));
                }
            }*/
            //logger.info("json转化为qualityJson对象: {}",qualityJson);
            if(StringUtils.isNoneBlank(qualityJson)){
                quality = mapper.readValue(qualityJson,  new TypeReference<List<TStorageQualitycheckSon>>(){});
                //logger.info("quality: {}",quality);
                if(quality.size()>0){
                	 for (int i = 0; i < quality.size(); i++) {
                         quality.get(i).setQualitycheckId(qualitycheck.getId());
                         if (quality.get(i).getEnumid().equals("2783")||quality.get(i).getEnumid().equals("2791")||quality.get(i).getEnumid().equals("2799")){
                             qualitycheck.setWater(quality.get(i).getSetValue());//主表水分-用于储粮卡查看页面上的粮情质检记录
                         }else if(quality.get(i).getEnumid().equals("2797")||quality.get(i).getEnumid().equals("2807")||quality.get(i).getEnumid().equals("2789")){
                             qualitycheck.setEatScore(quality.get(i).getSetValue());//品尝分
                         }else if (quality.get(i).getEnumid().equals("2790")){
                             qualitycheck.setGlutenWaterCount(quality.get(i).getSetValue());//面筋吸水量
                         }else if (quality.get(i).getEnumid().equals("6996")||quality.get(i).getEnumid().equals("2798")||quality.get(i).getEnumid().equals("2808")){
                             qualitycheck.setFatIndex(quality.get(i).getSetValue());//脂肪酸值
                         }
                         quality.get(i).setNumbering(Integer.valueOf(quality.get(i).getEnumid()));
                         storageQualitycheckService.saveOne(quality.get(i));
                         storageQualitycheckService.save(qualitycheck);
                     }
                }
            }
            // 修改fileIds对应附件的bid为当前质检的id.
//            businessFileService.updateFile(fileIds, qualitycheck.getId(),"qualitycheck");
            return ResponseEntity.ok(Constant.SUCCESS);
        } catch (IOException e) {
            e.printStackTrace();
            return ResponseEntity.failed(Constant.FAILED);
        }
       
    }

}