package com.chinaitop.depot.api.controller;

import com.chinaitop.depot.api.constant.Constant;
import com.chinaitop.depot.api.model.ResponseEntity;
import com.chinaitop.depot.api.service.BusinessService;
import com.chinaitop.depot.api.service.VentilationService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
@RequestMapping(value = "/api/ventilation")
@Api(value = "VentilationController", description = "通风控制类")
@SuppressWarnings("all")
public class VentilationController {

    final static Logger logger = LoggerFactory.getLogger(VentilationController.class);

    @Resource
    private VentilationService ventilationService;


    
   
    @RequestMapping(value = "/save", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.POST)
    @ApiOperation(value = "新增通风数据", notes = "新增通风数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ventilationJson", value = "表数据json串", paramType = "form")
    })
    public ResponseEntity planSave(@RequestBody String ventilationJson) {
        if (StringUtils.isBlank(ventilationJson)) {
            logger.error(Constant.JSON_FAILED);
            return ResponseEntity.failed(Constant.JSON_FAILED);
        }
        String save = null; 
        try {
            save = ventilationService.save(ventilationJson);
        } catch (Exception e) {
            logger.error(e.getMessage());
            return ResponseEntity.failed(Constant.FAILED);
        }

        return ResponseEntity.ok(save);
    }
    
    

}
