package com.chinaitop.depot.api.service.impl;

import com.chinaitop.depot.api.constant.Constant;
import com.chinaitop.depot.api.mapper.TFumigationPlanMapper;
import com.chinaitop.depot.api.mapper.TTestdataLayerMapper;
import com.chinaitop.depot.api.mapper.TTestdataMapper;
import com.chinaitop.depot.api.model.TPoints;
import com.chinaitop.depot.api.model.TTestdata;
import com.chinaitop.depot.api.model.TTestdataLayer;
import com.chinaitop.depot.api.model.TestdataDO;
import com.chinaitop.depot.api.model.fumigation.TFumigationAfter;
import com.chinaitop.depot.api.model.fumigation.TFumigationPesticide;
import com.chinaitop.depot.api.model.fumigation.TFumigationPlan;
import com.chinaitop.depot.api.model.fumigation.TFumigationProcess;
import com.chinaitop.depot.api.service.FumigationApiService;
//import com.chinaitop.depot.api.service.GrainApiService;
import com.chinaitop.depot.api.utils.JsonToObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class FumigationApiServiceImpl implements FumigationApiService {

    @Autowired
    private TFumigationPlanMapper tFumigationPlanMapper;

    @Transactional
    @Override
    public String saveFumigation(String fumigationJson) throws Exception {
        TFumigationPlan tFumigationPlan = JsonToObjectUtils.jsonTFumigationPlan(fumigationJson);
        //施药集合
        List<TFumigationPesticide> tPesticide = tFumigationPlan.getPesticideList();
        //熏蒸过程
        TFumigationProcess TFumigationProcess = tFumigationPlan.gettFumigationProcess();
        //熏蒸善后
        TFumigationAfter tFumigationAfter = tFumigationPlan.gettFumigationAfter();

        TFumigationPlan tPlan = tFumigationPlanMapper.selectPlanByPrimaryKey(tFumigationPlan.getId());
        if (tPlan != null) {
            return Constant.REPEAT_UPLOAD;
        }
        //主表插入数据
        tFumigationPlanMapper.insertPlanSelective(tFumigationPlan);
        //插入施药集合数据
        if (tPesticide.size() > Constant.ZERO) {
            for (TFumigationPesticide pesticide : tPesticide) {
                //字表插入数据
                tFumigationPlanMapper.insertPesticideSelective(pesticide);
            }
        }
        //熏蒸过程
        tFumigationPlanMapper.insertProcessSelective(TFumigationProcess);
        //熏蒸善后
        tFumigationPlanMapper.insertAfterSelective(tFumigationAfter);

        return Constant.SUCCESS;
    }
}
