package com.chinaitop.depot.api.service.impl;

import com.chinaitop.depot.api.constant.Constant;
import com.chinaitop.depot.api.mapper.TDcsdataMapper;
import com.chinaitop.depot.api.mapper.TQtdevinfoValueMapper;
import com.chinaitop.depot.api.model.TDcsdata;
import com.chinaitop.depot.api.model.TDcsdataExample;
import com.chinaitop.depot.api.model.TQtdevinfoValue;
import com.chinaitop.depot.api.service.GasDetectionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class GasDetectionServiceImpl implements GasDetectionService {

    @Autowired
    private TDcsdataMapper tDcsdataMapper;

    @Autowired
    private TQtdevinfoValueMapper qtdevinfoValueMapper;

    @Override
    public TDcsdata getById(String id) {
        TDcsdata dcsdata = null;
        TDcsdataExample example = new TDcsdataExample();
        TDcsdataExample.Criteria criteria = example.createCriteria();
        criteria.andIdEqualTo(id);
        List<TDcsdata> tDcsdata1 = tDcsdataMapper.selectByExample(example);
        if (tDcsdata1.size() > Constant.ZERO) {
            dcsdata = tDcsdata1.get(0);
        }
        return dcsdata;
    }

    @Transactional
    @Override
    public void insertBatch(List<TDcsdata> tDcsdata) {
        tDcsdataMapper.insertBatch(tDcsdata);
    }

    @Transactional
    @Override
    public void insertValueBatch(List<TQtdevinfoValue> tQtdevinfoValues) {
        qtdevinfoValueMapper.insertBatch(tQtdevinfoValues);
    }
}
