package com.chinaitop.depot.api.service.impl;

import com.chinaitop.depot.api.constant.Constant;
import com.chinaitop.depot.api.mapper.TCcdataMapper;
import com.chinaitop.depot.api.mapper.TCcvalueMapper;
import com.chinaitop.depot.api.model.TCcdata;
import com.chinaitop.depot.api.model.TCcdataExample;
import com.chinaitop.depot.api.model.TCcvalue;
import com.chinaitop.depot.api.service.InsectPestDetectionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

@Service
public class InsectPestDetectionServiceImpl implements InsectPestDetectionService {

    @Autowired
    private TCcdataMapper tCcdataMapper;

    @Autowired
    private TCcvalueMapper tCcvalueMapper;

    @Override
    public List<TCcdata> getByCodeAndTimes(List<String> cDcsCodes, List<Date> cTimes, List<Integer> tdhs) {
        TCcdataExample example = new TCcdataExample();
        TCcdataExample.Criteria criteria = example.createCriteria();
        if ((cDcsCodes != null && cDcsCodes.size() > 0) && (cTimes != null && cTimes.size() > 0) && (tdhs != null && tdhs.size() > 0)) {
            criteria.andVCcCodeIn(cDcsCodes);
            criteria.andVUpdateTimeIn(cTimes);
            criteria.andITdhIn(tdhs);
            List<TCcdata> tCcdata = tCcdataMapper.selectByExample(example);
            return tCcdata;
        }
        return null;
    }

    @Override
    public TCcdata getById(String id) {
        TCcdata ccdata = null;
        TCcdataExample example = new TCcdataExample();
        TCcdataExample.Criteria criteria = example.createCriteria();
        criteria.andIdEqualTo(id);
        List<TCcdata> tCcdata = tCcdataMapper.selectByExample(example);
        if (tCcdata.size() > Constant.ZERO) {
            ccdata = tCcdata.get(0);
        }
        return ccdata;
    }

    @Transactional
    @Override
    public void insertBatch(List<TCcdata> tCcdata) {
        tCcdataMapper.insertBatch(tCcdata);
    }

    @Transactional
    @Override
    public void insertValueBatch(List<TCcvalue> tCcvalue) {
        tCcvalueMapper.insertBatch(tCcvalue);
    }
}
