package com.chinaitop.depot.api.service.impl;

import com.chinaitop.depot.api.mapper.qualitycheck.TStorageFoodbasicInfoLocationMapper;
import com.chinaitop.depot.api.model.qualitycheck.TStorageFoodbasicInfoLocation;
import com.chinaitop.depot.api.model.qualitycheck.TStorageFoodbasicInfoLocationExample;
import com.chinaitop.depot.api.service.TStorageFoodbasicInfoLocationService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author sunhongbing
 * @Date 2017/10/20
 */
@Service
public class TStorageFoodbasicInfoLocationServiceImpl implements TStorageFoodbasicInfoLocationService {
    @Resource
    private TStorageFoodbasicInfoLocationMapper foodbasicInfoLocationMapper;


    @Override
    public void save(TStorageFoodbasicInfoLocation foodbasicInfoLocation) {
        if (foodbasicInfoLocation.getId() == null)
            foodbasicInfoLocationMapper.insert(foodbasicInfoLocation);//新增数据
        else
            foodbasicInfoLocationMapper.updateByPrimaryKey(foodbasicInfoLocation);//修改数据
    }



    @Override
    public List<TStorageFoodbasicInfoLocation> getFoodbasicInfoLocationByWarehouseCode(Integer houseId, Integer wareHouseId) {
        TStorageFoodbasicInfoLocationExample example = new TStorageFoodbasicInfoLocationExample();
        TStorageFoodbasicInfoLocationExample.Criteria criteria = example.createCriteria();
    	criteria.andHouseIdEqualTo(houseId);
    	criteria.andWarehouseIdEqualTo(wareHouseId);
    	return foodbasicInfoLocationMapper.selectByExample(example);
    }
}
