package com.chinaitop.depot.api.service.impl;

import com.alibaba.fastjson.JSON;
import com.chinaitop.depot.api.constant.Constant;
import com.chinaitop.depot.api.mapper.TJobApplicationMapper;
import com.chinaitop.depot.api.mapper.TJobMapper;
import com.chinaitop.depot.api.mapper.TVentilationMapper;
import com.chinaitop.depot.api.model.TJob;
import com.chinaitop.depot.api.model.TJobApplication;
import com.chinaitop.depot.api.model.TVentilation;
import com.chinaitop.depot.api.service.VentilationService;
import com.fasterxml.jackson.databind.ObjectMapper;

import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class VentilationServiceImpl implements VentilationService {

	public static ObjectMapper mapper = new ObjectMapper();
	
    @Autowired
    private TJobApplicationMapper tJobApplicationMapper;
    
    @Autowired
    private TJobMapper tJobMapper;
    
    @Autowired
    private TVentilationMapper tVentilationMapper;

    @Transactional
	@Override
	public String save(String ventilationJson) throws Exception {
		// TODO Auto-generated method stub
    	JSONObject jsonObject = new JSONObject(ventilationJson);
    	/*JSONObject TtJobApplicationObj = jsonObject.getJSONObject("tfjh");
    	JSONObject TJobObj = jsonObject.getJSONObject("tfzy");
    	JSONObject TVentilationObj = jsonObject.getJSONObject("tfjl");*/
    	String tfjh = jsonObject.getString("tfjh");
    	String tfzy = jsonObject.getString("tfzy");
    	String tfjl = jsonObject.getString("tfjl");
    	TJobApplication tJobApplication = JSON.parseObject(tfjh, TJobApplication.class);
    	TJob tJob = JSON.parseObject(tfzy, TJob.class);
    	TVentilation tVentilation = JSON.parseObject(tfjl, TVentilation.class);
    	tJobApplicationMapper.insert(tJobApplication);
    	tJobMapper.insert(tJob);
    	tVentilationMapper.insert(tVentilation);
    	
		return Constant.SUCCESS;
	}



    
}
